// All database related API calls

import { BackendQueryFormat } from "../../querybuilder/query-utils/BackendQueryFormat";
import { useAuthorizationCache, useSessionCache } from "../store";

export const useQueryAPI = (domain: string) => {
    const cache = useSessionCache();
    const { accessToken } = useAuthorizationCache();

    async function execute(query: BackendQueryFormat) {

        const response = await fetch(`https://${domain}/query/execute/`, {
            method: 'POST',
            credentials: 'same-origin',
            headers: new Headers({
                Authorization:
                    'Bearer ' + accessToken,
            }),
            body: JSON.stringify(query)
        });

        if (!response?.ok) {
            const ret = await response.text();
            console.error(response, ret);
        }
        const ret = await response.json();
        console.log('Sent Query EXECUTION', ret);
    }

    async function retrieveCachedQuery(queryID: string) {
        // TODO: check if this method is needed!

        // const response = await fetch(`https://${domain}/query/retrieve-cached/`, {
        //     method: 'POST',
        //     credentials: 'same-origin',
        //     headers: new Headers({
        //         Authorization:
        //             'Bearer ' + accessToken,
        //     }),
        //     body: JSON.stringify({ queryID })
        // });

        // if (!response?.ok) {
        //     const ret = await response.text();
        //     console.error(response, ret);
        // }
        // // const ret = await response.json();
        // console.log(response);
    }

    return { execute, retrieveCachedQuery };
};
